%define eclipse_base     %{_libdir}/eclipse
%define eclipse_dropin   %{_datadir}/eclipse/dropins

Name:      eclipse-dltk
Version:   1.0.0
Release:   0.3.M5%{?dist}
Summary:   Dynamic Languages Toolkit (DLTK) Eclipse plugin
Group:     System Environment/Libraries
License:   EPL
URL:       http://www.eclipse.org/dltk/

# source tarball and the script used to generate it from upstream's source control
# script usage:
# $ sh get-dltk.sh
Source0:   dltk-%{version}.tar.gz
Source1:   get-dltk.sh

BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)

BuildArch:        noarch

BuildRequires:    java-devel
BuildRequires:    jpackage-utils
BuildRequires:    eclipse-pde >= 1:3.4.1
BuildRequires:    eclipse-emf
BuildRequires:    eclipse-mylyn
Requires:         java
Requires:         jpackage-utils
Requires:         eclipse-platform >= 1:3.4.1

%description
Dynamic Languages Toolkit (DLTK) is a tool for vendors, researchers, and users
who rely on dynamic languages. DLTK is comprised of a set of extensible
frameworks designed to reduce the complexity of building full featured
development environments for dynamic languages such as PHP and Perl.

%package   ruby
Summary:   Ruby Eclipse plugin
Group:     Development/Tools
Requires:  %{name} = %{version}-%{release}

%description ruby
Ruby development environment for Eclipse based on the Eclipse Dynamic
Languages Toolkit (DLTK).

%package   tcl
Summary:   TCL Eclipse plugin
Group:     Development/Tools
Requires:  %{name} = %{version}-%{release}
Requires:  eclipse-emf

%description tcl
TCL development environment for Eclipse based on the Eclipse Dynamic
Languages Toolkit (DLTK).

%package   itcl
Summary:   Incr TCL extension for the TCL Eclipse plugin
Group:     Development/Tools
Requires:  %{name}-tcl = %{version}-%{release}

%description itcl
Incr TCL extension for the TCL Eclipse plugin.

%package   xotcl
Summary:   XOTCL extension for the TCL Eclipse plugin
Group:     Development/Tools
Requires:  %{name}-tcl = %{version}-%{release}

%description xotcl
XOTCL extension for the TCL Eclipse plugin.

%package   mylyn
Summary:   Mylyn integration for Eclipse DLTK projects
Group:     Development/Tools
Requires:  %{name} = %{version}-%{release}
Requires:  eclipse-mylyn

%description mylyn
Mylyn task-focused UI integration for Eclipse Dynamic Languages Toolkit
(DLTK) projects.

# TODO: Remote Projects via DSDP TM integration, Python IDE, Javascript IDE

%prep
%setup -q -n dltk-%{version}

# make sure upstream hasn't sneaked in any jars we don't know about
JARS=""
for j in `find -name "*.jar"`; do
  if [ ! -L $j ]; then
    JARS="$JARS $j"
  fi
done
if [ ! -z "$JARS" ]; then
   echo "These jars should be deleted and symlinked to system jars: $JARS"
   exit 1
fi

%build
# build all features
%{eclipse_base}/buildscripts/pdebuild -f org.eclipse.dltk.core \
  -d "emf mylyn" -a "-DjavacTarget=1.5 -DjavacSource=1.5"
%{eclipse_base}/buildscripts/pdebuild -f org.eclipse.dltk.ruby \
  -d "emf mylyn" -a "-DjavacTarget=1.5 -DjavacSource=1.5"
%{eclipse_base}/buildscripts/pdebuild -f org.eclipse.dltk.tcl \
  -d "emf mylyn" -a "-DjavacTarget=1.5 -DjavacSource=1.5"
%{eclipse_base}/buildscripts/pdebuild -f org.eclipse.dltk.itcl \
  -d "emf mylyn" -a "-DjavacTarget=1.5 -DjavacSource=1.5"
%{eclipse_base}/buildscripts/pdebuild -f org.eclipse.dltk.xotcl \
  -d "emf mylyn" -a "-DjavacTarget=1.5 -DjavacSource=1.5"
%{eclipse_base}/buildscripts/pdebuild -f org.eclipse.dltk.mylyn \
  -d "emf mylyn" -a "-DjavacTarget=1.5 -DjavacSource=1.5"

%install
rm -rf %{buildroot}
install -d -m 755 %{buildroot}%{eclipse_dropin}
unzip -q -d %{buildroot}%{eclipse_dropin}/dltk-core  build/rpmBuild/org.eclipse.dltk.core.zip
unzip -q -d %{buildroot}%{eclipse_dropin}/dltk-ruby  build/rpmBuild/org.eclipse.dltk.ruby.zip
unzip -q -d %{buildroot}%{eclipse_dropin}/dltk-tcl   build/rpmBuild/org.eclipse.dltk.tcl.zip
unzip -q -d %{buildroot}%{eclipse_dropin}/dltk-itcl  build/rpmBuild/org.eclipse.dltk.itcl.zip
unzip -q -d %{buildroot}%{eclipse_dropin}/dltk-xotcl build/rpmBuild/org.eclipse.dltk.xotcl.zip
unzip -q -d %{buildroot}%{eclipse_dropin}/dltk-mylyn build/rpmBuild/org.eclipse.dltk.mylyn.zip

%clean
rm -rf %{buildroot}

%files
%defattr(-,root,root,-)
%{eclipse_dropin}/dltk-core
%doc org.eclipse.dltk.core-feature/rootfiles/*

%files ruby
%defattr(-,root,root,-)
%{eclipse_dropin}/dltk-ruby
%doc org.eclipse.dltk.ruby-feature/rootfiles/*

%files tcl
%defattr(-,root,root,-)
%{eclipse_dropin}/dltk-tcl
%doc org.eclipse.dltk.tcl-feature/rootfiles/*

%files itcl
%defattr(-,root,root,-)
%{eclipse_dropin}/dltk-itcl
%doc org.eclipse.dltk.itcl-feature/rootfiles/*

%files xotcl
%defattr(-,root,root,-)
%{eclipse_dropin}/dltk-xotcl
%doc org.eclipse.dltk.xotcl-feature/rootfiles/*

%files mylyn
%defattr(-,root,root,-)
%{eclipse_dropin}/dltk-mylyn
%doc org.eclipse.dltk.mylyn-feature/rootfiles/*

%changelog
* Thu Apr 02 2009 Mat Booth <fedora@matbooth.co.uk> 1.0.0-0.3.M5
- Fix files listed twice warnings.

* Thu Apr 02 2009 Mat Booth <fedora@matbooth.co.uk> 1.0.0-0.2.M5
- Drop GCJ AOT support.

* Mon Mar 30 2009 Mat Booth <fedora@matbooth.co.uk> 1.0.0-0.1.M5
- Initial release.
